//
//  PointsBrowser.m
//  BeeLine
//
//  Created by William Ray on 2/6/12.
//  Copyright (c) 2012 SGF. All rights reserved.
//

#import "PointsBrowser.h"

@implementation PointsBrowser
@synthesize _aBrowser;
BetterList *ptsList;

- (void) awakeFromNib
{
    [_aBrowser setDoubleAction: @selector(rowDoubleClicked:)];
    [_aBrowser reloadColumn: 0];
}

- (void) setPointsList: (BetterList*) pointsList;
{
    ptsList = pointsList;
    // NSLog(@"setting pointslist");
}

- (void) refreshPoints
{
    // NSLog(@"pointsList should reload");
    [_aBrowser reloadColumn: 0];
}

- (void)browser:(NSBrowser *)browser createRowsForColumn:(NSInteger)column inMatrix:(NSMatrix *)matrix
{
    NSString *name;
    NSBrowserCell *cell;
    
    // NSLog(@"Entering browser createrows");
    
    myPointType *pointRows = calloc(100,sizeof(myPointType));
    __block int numRows = 0;
    
    void(^pointsCollector)(void*) = ^(void* toCollect)
    {
        pointRows[numRows].myX = ((myPointType*)toCollect)->myX - 1.0;
        pointRows[numRows].myY = ((myPointType*)toCollect)->myY - 1.0;
        // NSLog(@"setting %f %f",pointRows[numRows].myX - 1.0, pointRows[numRows].myY - 1.0);
        // NSLog(@"pointRows at %d rows",numRows+1);
        numRows++;
    };
    
    [ptsList walkList:pointsCollector];
    
    [matrix renewRows: numRows columns: 1];
    [matrix sizeToCells];
    for(int j=0;j<numRows;j++)
    {
        name = [NSMutableString stringWithFormat:@"%0.2f %0.2f",pointRows[j].myX,pointRows[j].myY];
        cell = [matrix cellAtRow: j column: 0];
        [cell setRepresentedObject: [NSNumber numberWithInt:j+1]];
        [cell setStringValue: name];
        [cell setLeaf: YES];
    }
}


- (IBAction) rowSelected: (id)sender
{
    NSBrowserCell *cell = [_aBrowser selectedCellInColumn: 0];
    NSLog(@"ptsBrowser: selected <%@> at %d",cell.stringValue, [cell.representedObject intValue]);
}

- (IBAction) rowDoubleClicked: (id)sender
{
    NSBrowserCell *cell = [_aBrowser selectedCellInColumn: 0];
    NSLog(@"ptsBrowser - doubleclick : selected <%@> at %d",cell.stringValue, [cell.representedObject intValue]);
}


@end
