//
//  QuartzGrough.m
//  BeeLine
//
//  Created by William Ray on 2/5/12.
//  Copyright (c) 2012 SGF. All rights reserved.
//

#import "QuartzGrough.h"

@implementation QuartzGrough

@synthesize anX;
@synthesize anY;

BetterList *pointsList;

float normX;
float normY;
bool  plotting = false;

//Sloppyness follows...
CGPoint addLines[100];
int  linesAdded = 0;
float lastX, lastY;

- (id) init{
    self = [super init];
    return self ;
}

- (id) initWithFrame : (NSRect) frame{
    NSLog(@"QuartzGroughView initWithFrame");
    self = [super initWithFrame:frame];
    return self;
}

inline double rad(double deg){
    return deg / 180.0 * M_PI;
}

- (NSPoint) center : (NSRect) r{
    NSPoint result ;
    result.x = r.origin.x + r.size.width / 2 ;
    result.y = r.origin.y + r.size.height/ 2 ;
    return result ;
}

- (NSPoint) size : (NSRect) r{
    NSPoint result ;
    NSLog(@"received rect %f %f",r.size.width,r.size.height);
    result.x = r.size.width / 2 ;
    result.y = r.size.height/ 2 ;
    return result ;
}

- (void) doaPoint: (const CGContextRef) context
           margin: (int)                insetMargin
              atX: (float)              thisX
              atY: (float)              thisY
           ptSize: (float)              thisSize
{
    CGContextSetLineWidth(context, thisSize);
    NSPoint size = [self size:[self bounds]];
    CGPoint pointBits[] =
    {
        CGPointMake(((size.x - insetMargin) * thisX)+insetMargin, ((size.y - insetMargin) * thisY)+insetMargin),
        CGPointMake(((size.x - insetMargin) * thisX)+insetMargin, ((size.y - insetMargin) * thisY)+insetMargin)
    };
    CGContextAddLines(context, pointBits, sizeof(pointBits)/sizeof(pointBits[0]));
    CGContextStrokePath(context);
}

- (void) doaLine: (const CGContextRef) context
          margin: (int)                insetMargin
             atX: (float)              thisX
             atY: (float)              thisY
          ptSize: (float)              thisSize
{
    NSPoint size = [self size:[self bounds]];
    
    addLines[linesAdded++] = CGPointMake(((size.x - insetMargin) * thisX)+insetMargin,
                                         ((size.y - insetMargin) * thisY)+insetMargin);
}

- (void) drawRect : (NSRect) dirtyRect
{
	CGContextRef context = (CGContextRef)[[NSGraphicsContext currentContext] graphicsPort];
    
    NSLog(@"in drawRect");
    NSRect r = [self bounds] ;

    int margin = 5;

    [[NSColor whiteColor] set];
    [NSBezierPath fillRect:r];
    
    CGContextSetShadow(context, CGSizeMake(3.0f, -3.0f), 2.0f);
    CGContextSetRGBStrokeColor(context, 0.0, 0.0, 0.0, 1.0);

    CGContextSetLineCap(context,kCGLineCapRound);
    if (plotting)
    {
        void(^pointsDrawer)(void*) = ^(void* toDraw)
        {
            [self doaPoint:context margin:margin
                       atX:((myPointType*)toDraw)->myX
                       atY:((myPointType*)toDraw)->myY
                    ptSize:5];
        };
        [pointsList walkList:pointsDrawer];

        void(^linesDrawer)(void*) = ^(void* toDraw)
        {
            [self doaLine:context margin:margin
                      atX:((myPointType*)toDraw)->myX
                      atY:((myPointType*)toDraw)->myY
                   ptSize:5];
        };
        
        CGContextSetLineWidth(context, 2.0);
        
        [pointsList walkList:linesDrawer];
        CGContextAddLines(context, addLines, linesAdded);
        CGContextStrokePath(context);
        linesAdded = 0;
        
        
        [self doaPoint:context margin:margin
                   atX:normX
                   atY:normY
                ptSize:10];
    }
}

- (void) update
{
    [self setNeedsDisplay:YES];
    [[NSApp dockTile] display];
}


-(void) plotUpdate
{
    void(^pointsPrinter)(void*) = ^(void* toPrint)
    {
        NSLog(@"point at %f, %f",((myPointType*)toPrint)->myX - 1.0, ((myPointType*)toPrint)->myY - 1.0);
    };
    
    
    NSLog(@"anX = %f : anY = %f", anX, anY);
    // NSLog(@"pointslistaddress %dl",pointsList);

    normX = anX + 1.0;
    normY = anY + 1.0;
    myPointType *aPoint = malloc(sizeof(myPointType));
    aPoint->myX = normX;
    aPoint->myY = normY;
    
    if(!plotting)
    {
        plotting = true;
        pointsList = [[BetterList alloc] initDLList: aPoint];
    }
    else
    {
        [pointsList append:aPoint];
    }
    [self update];
    [pointsList walkList:pointsPrinter];
    
}

@end

