//
//  Lists.h
//  Lists
//
//  Created by William Ray on 1/28/12.
//  Copyright (c) 2012 SGF. All rights reserved.
//

#import <Foundation/Foundation.h>

typedef struct DLNode DLNode;
struct DLNode {
	void   *item;
	DLNode *next;
	DLNode *prev;
};

@interface ListsToo : NSObject {
@private 
	DLNode *head;
    DLNode *tail;
	DLNode *current;
@public
}	

- (id)initDLList: (void*)anitem;
- (void)prepend:  (void*)anitem;
- (void)append:   (void*)anitem;
- (void)insertbefore:   (void*)anitem;
- (void)insertafter:    (void*)anitem;
- (void)replace:  (void*)anitem;
- (void)remove;
- (void)walkListSimple;

// No return value
// |    Method name
// |    |          Return type of block argument
// |    |          |     Argument is a Function-Block
// |    |          |     |  Function-Block takes a void* as an argument
// |    |          |     |  |       Name of accepted Function-Block
// |    |          |     |  |       |
- (void)walkList: (void (^)(void*)) doWhat;

- (void*)gotoHead;
- (void*)gotoTail;
- (void*)gotoItemNum: (int)itemNum;
- (void*)getNext;
- (void*)getPrev;
- (void*)getCurrent;

@end
