//
//  BetterListTests.m
//  BetterListTests
//
//  Created by William Ray on 2/7/12.
//  Copyright (c) 2012 SGF. All rights reserved.
//

#import "BetterListTests.h"
#import "BetterList.h"

@implementation BetterListTests

BetterList *myList;

- (void)setUp
{
    [super setUp];
    NSLog(@"Starting Unit Tests");
    
    int *anInteger;
    
    anInteger = malloc(sizeof(int));
    *anInteger = 12;
    
    NSLog(@"Creating a List with an integer pointer, memory %lu value %d", (unsigned long)anInteger, *anInteger);
    myList = [[BetterList alloc] initDLList: anInteger];
    NSLog(@"Successfully created");
    // Set-up code here.
}

- (void)tearDown
{
    // Tear-down code here.
    
    [super tearDown];
}

- (void)testExample
{
    int *retrieved;
    int *assigned;
    
    //  No return value
    //  |    Declaring a Block 
    //  |    |Name of Block 
    //  |    ||           Block takes a void* as an argument 
    //  |    ||           |        Yeah, we really meant it's a block 
    //  |    ||           |        | And it takes a void* as an argument 
    //  |    ||           |        | |     Name of argument to block
    //  |    ||           |        | |     | 
    void(^intPrinter)(void*) = ^(void* toPrint)
    {
        NSLog(@"logging %d",*(int*)toPrint);
    };
    
    
    
    // This variable can be updated in the block, even though at run time,
    // the anonymous function is no-longer in this context
    __block int cake = 0;
    
    void(^intSummer)(void*) = ^(void* toSum)
    {
        cake = cake + *(int*)toSum;
    };
    
    
    
    __block NSMutableString *listContents = NULL;
    
    void(^listConcat)(void*) = ^(void *toConcat)
    {
        if(listContents)
        {
            [listContents appendFormat:@" %d",*(int*)toConcat];
        }
        else
        {
            listContents = [NSMutableString stringWithFormat:@"%d",*(int*)toConcat];
        }
    };
    
    retrieved = myList.getCurrent;
    NSLog(@"retrieved the current value from %lu contains %d\n", (unsigned long)retrieved, *retrieved);
    
    assigned = malloc(sizeof(int));
    *assigned = 23;
    NSLog(@"Inserting in List with an integer pointer, memory %lu value %d", (unsigned long)assigned, *assigned);
    [myList insertafter:assigned];
    NSLog(@"Successfully inserted");
    
    retrieved = myList.getCurrent;
    NSLog(@"retrieved the current value from %lu contains %d\n", (unsigned long)retrieved, *retrieved);
    
    [myList gotoHead];
    retrieved = myList.getCurrent;
    NSLog(@"retrieved the current value from %lu contains %d\n", (unsigned long)retrieved, *retrieved);
    
    [myList getNext];
    retrieved = myList.getCurrent;
    NSLog(@"retrieved the current value from %lu contains %d\n", (unsigned long)retrieved, *retrieved);
    
    assigned = malloc(sizeof(int));
    *assigned = 36;
    NSLog(@"Inserting in List with an integer pointer, memory %lu value %d", (unsigned long)assigned, *assigned);
    [myList insertafter:assigned];
    
    NSLog(@"Successfully inserted");
    
    retrieved = myList.getCurrent;
    NSLog(@"retrieved the current value from %lu contains %d\n", (unsigned long)retrieved, *retrieved);
    
    [myList gotoHead];
    retrieved = myList.getCurrent;
    NSLog(@"retrieved the current value from %lu contains %d\n", (unsigned long)retrieved, *retrieved);
    
    [myList getNext];
    retrieved = myList.getCurrent;
    NSLog(@"retrieved the current value from %lu contains %d\n", (unsigned long)retrieved, *retrieved);
    
    [myList getNext];
    retrieved = myList.getCurrent;
    NSLog(@"retrieved the current value from %lu contains %d\n", (unsigned long)retrieved, *retrieved);
    
    [myList gotoHead];
    [myList getNext];
    
    assigned = malloc(sizeof(int));
    *assigned = 42;
    NSLog(@"Inserting in List with an integer pointer, memory %lu value %d", (unsigned long)assigned, *assigned);
    [myList insertafter:assigned];
    
    [myList gotoHead];
    retrieved = myList.getCurrent;
    NSLog(@"retrieved the current value from %lu contains %d\n", (unsigned long)retrieved, *retrieved);
    
    [myList getNext];
    retrieved = myList.getCurrent;
    NSLog(@"retrieved the current value from %lu contains %d\n", (unsigned long)retrieved, *retrieved);
    
    [myList getNext];
    retrieved = myList.getCurrent;
    NSLog(@"retrieved the current value from %lu contains %d\n", (unsigned long)retrieved, *retrieved);
    
    [myList getNext];
    retrieved = myList.getCurrent;
    NSLog(@"retrieved the current value from %lu contains %d\n", (unsigned long)retrieved, *retrieved);
    
    [myList getNext];
    retrieved = myList.getCurrent;
    NSLog(@"retrieved the current value from %lu contains %d\n", (unsigned long)retrieved, *retrieved);
    
    
    [myList gotoHead];
    
    assigned = malloc(sizeof(int));
    *assigned = 18;
    NSLog(@"Inserting in List with an integer pointer, memory %lu value %d", (unsigned long)assigned, *assigned);
    [myList insertafter:assigned];
    
    [myList gotoHead];
    retrieved = myList.getCurrent;
    NSLog(@"retrieved the current value from %lu contains %d\n", (unsigned long)retrieved, *retrieved);
    
    [myList getNext];
    retrieved = myList.getCurrent;
    NSLog(@"retrieved the current value from %lu contains %d\n", (unsigned long)retrieved, *retrieved);
    
    [myList getNext];
    retrieved = myList.getCurrent;
    NSLog(@"retrieved the current value from %lu contains %d\n", (unsigned long)retrieved, *retrieved);
    
    [myList getNext];
    retrieved = myList.getCurrent;
    NSLog(@"retrieved the current value from %lu contains %d\n", (unsigned long)retrieved, *retrieved);
    
    [myList getNext];
    retrieved = myList.getCurrent;
    NSLog(@"retrieved the current value from %lu contains %d\n", (unsigned long)retrieved, *retrieved);
    
    NSLog(@"outta be botta");
    
    [myList getPrev];
    retrieved = myList.getCurrent;
    NSLog(@"retrieved the current value from %lu contains %d\n", (unsigned long)retrieved, *retrieved);
    
    [myList getPrev];
    retrieved = myList.getCurrent;
    NSLog(@"retrieved the current value from %lu contains %d\n", (unsigned long)retrieved, *retrieved);
    
    [myList getPrev];
    retrieved = myList.getCurrent;
    NSLog(@"retrieved the current value from %lu contains %d\n", (unsigned long)retrieved, *retrieved);
    
    [myList getPrev];
    retrieved = myList.getCurrent;
    NSLog(@"retrieved the current value from %lu contains %d\n", (unsigned long)retrieved, *retrieved);
    
    [myList getPrev];
    retrieved = myList.getCurrent;
    NSLog(@"retrieved the current value from %lu contains %d\n", (unsigned long)retrieved, *retrieved);
    
    
    
    [myList gotoTail];
    retrieved = myList.getCurrent;
    NSLog(@"retrieved the current value from %lu contains %d\n", (unsigned long)retrieved, *retrieved);
    
    [myList getPrev];
    retrieved = myList.getCurrent;
    NSLog(@"retrieved the current value from %lu contains %d\n", (unsigned long)retrieved, *retrieved);
    
    [myList getPrev];
    retrieved = myList.getCurrent;
    NSLog(@"retrieved the current value from %lu contains %d\n", (unsigned long)retrieved, *retrieved);
    
    [myList getPrev];
    retrieved = myList.getCurrent;
    NSLog(@"retrieved the current value from %lu contains %d\n", (unsigned long)retrieved, *retrieved);
    
    [myList getPrev];
    retrieved = myList.getCurrent;
    NSLog(@"retrieved the current value from %lu contains %d\n", (unsigned long)retrieved, *retrieved);
    [myList getPrev];
    retrieved = myList.getCurrent;
    NSLog(@"retrieved the current value from %lu contains %d\n", (unsigned long)retrieved, *retrieved);
    
    [myList getPrev];
    retrieved = myList.getCurrent;
    NSLog(@"retrieved the current value from %lu contains %d\n", (unsigned long)retrieved, *retrieved);
    
    [myList walkListSimple];
    [myList gotoHead];
    [myList getNext];
    assigned = malloc(sizeof(int));
    *assigned = 78;
    [myList insertafter:assigned];
    [myList walkListSimple];
    
    [myList gotoTail];
    [myList getPrev];
    assigned = malloc(sizeof(int));
    *assigned = 51;
    [myList insertafter:assigned];
    [myList walkList:intPrinter];
    
    listContents = NULL;
    [myList walkList:listConcat];
    NSLog(@"%@",listContents);
    
    [myList gotoTail];
    [myList getPrev];
    [myList getPrev];
    [myList getPrev];
    [myList remove];
    [myList walkList:intPrinter];
    
    [myList gotoTail];
    [myList remove];
    [myList walkList:intPrinter];
    
    [myList gotoHead];
    [myList remove];
    [myList walkList:intPrinter];
    
    [myList gotoHead];
    [myList getNext];
    [myList remove];
    [myList walkList:intPrinter];
    
    [myList gotoHead];
    [myList getNext];
    assigned = malloc(sizeof(int));
    *assigned = 98;
    [myList insertbefore:assigned];
    [myList walkList:intPrinter];
    
    [myList gotoHead];
    assigned = malloc(sizeof(int));
    *assigned = 87;
    [myList insertbefore:assigned];
    [myList walkList:intPrinter];
    
    [myList gotoTail];
    assigned = malloc(sizeof(int));
    *assigned = 74;
    [myList insertbefore:assigned];
    [myList walkList:intPrinter];
    
    [myList gotoHead];
    [myList getNext];
    assigned = malloc(sizeof(int));
    *assigned = 123;
    [myList replace:assigned];
    [myList walkList:intPrinter];
    
    assigned = malloc(sizeof(int));
    *assigned = 234;
    [myList prepend:assigned];
    [myList walkList:intPrinter];
    assigned = malloc(sizeof(int));
    *assigned = 345;
    [myList append:assigned];
    [myList walkList:intPrinter];
    
    assigned = malloc(sizeof(int));
    *assigned = 456;
    [myList getNext];
    [myList getNext];
    [myList getNext];
    [myList replace:assigned];
    [myList walkList:intPrinter];
    
    [myList gotoHead];
    [myList getNext];
    [myList remove];
    [myList remove];
    [myList walkList:intPrinter];
    [myList remove];
    [myList walkList:intPrinter];
    [myList getNext];
    [myList remove];
    [myList remove];
    [myList walkList:intPrinter];
    
    cake = 0;
    [myList walkList:intSummer];
    NSLog(@"List sums to %d", cake);
    
    listContents = NULL;
    [myList walkList:listConcat];
    NSLog(@"%@",listContents);
    
    assigned = malloc(sizeof(int));
    *assigned = 1236;
    [myList gotoItemNum:1];
    [myList insertafter:assigned];
    
    assigned = malloc(sizeof(int));
    *assigned = 1232;
    [myList prepend:assigned];
    
    assigned = malloc(sizeof(int));
    *assigned = 3232;
    [myList append:assigned];
    
    assigned = malloc(sizeof(int));
    *assigned = 4210;
    [myList gotoItemNum:2];
    [myList insertafter:assigned];
    
    listContents = NULL;
    [myList walkList:listConcat];
    NSLog(@"%@",listContents);
    
    //    STFail(@"Unit tests are not implemented yet in ListsTests");
}

@end
