//
//  IGrough.m
//  iBLine
//
//  Created by William Ray on 2/24/12.
//  Copyright (c) 2012 SGF. All rights reserved.
//


#import "IGrough.h"


@implementation IGrough

//Sloppyness follows...
CGPoint addLines[100];
int  linesAdded = 0;
float lastX, lastY;

- (CGPoint) size : (CGRect) r {
    CGPoint result ;
	result.x = r.size.width / 2 ;
	result.y = r.size.height/ 2 ;
	return result ;
}

- (void) doaPoint: (const CGContextRef) context
           margin: (int)                insetMargin
              atX: (float)              thisX
              atY: (float)              thisY
           ptSize: (float)              thisSize
{
    CGPoint size = [self size:self.frame];
    
    CGColorSpaceRef myColorspace;
    myColorspace = CGColorSpaceCreateDeviceRGB();
	CGContextSetLineWidth(context, thisSize);
    CGContextSetShadow(context, CGSizeMake(3.0f, -3.0f), 2.0f);
    CGContextSetRGBStrokeColor(context, 0.0, 0.0, 0.0, 1.0);
	CGContextSetLineCap(context,kCGLineCapRound);
    
	CGPoint pointBits[] =
	{
        CGPointMake(((size.x - insetMargin) * thisX)+insetMargin,
                    ((size.y - insetMargin) * (2.0-thisY))+insetMargin),
        CGPointMake(((size.x - insetMargin) * thisX)+insetMargin,
                    ((size.y - insetMargin) * (2.0-thisY))+insetMargin)
	};
	CGContextAddLines(context, pointBits, sizeof(pointBits)/sizeof(pointBits[0]));
	CGContextStrokePath(context);
}


- (void) doaLine: (const CGContextRef) context
          margin: (int)                insetMargin
             atX: (float)              thisX
             atY: (float)              thisY
          ptSize: (float)              thisSize
{
    CGPoint size = [self size:self.frame];
    
    addLines[linesAdded++] = CGPointMake(((size.x - insetMargin) * thisX)+insetMargin,
                                         ((size.y - insetMargin) * (2.0 - thisY))+insetMargin);
}


- (void) drawRect : (CGRect) dirtyRect
{
	int margin = 5;
    
    CGContextRef context = UIGraphicsGetCurrentContext();
    CGColorSpaceRef myColorspace;
    myColorspace = CGColorSpaceCreateDeviceRGB();
    
    CGContextSaveGState(context);
    
    CGFloat myBGColor[4];
    myBGColor[0] = 1.0; myBGColor[1] = 1.0; myBGColor[2] = 1.0; myBGColor[3] = 1.0;
    CGContextSetFillColorWithColor(context, CGColorCreate(myColorspace, myBGColor));
    CGContextFillRect(context,self.bounds);
    
    if(pointsList)
    {
        void(^pointsDrawer)(void*) = ^(void* toDraw)
        {
            [self doaPoint:context margin:margin
                       atX:((myPointType*)toDraw)->myX
                       atY:((myPointType*)toDraw)->myY
                    ptSize:5];
        };
        [pointsList walkList:pointsDrawer];
        
        void(^linesDrawer)(void*) = ^(void* toDraw)
        {
            [self doaLine:context margin:margin
                      atX:((myPointType*)toDraw)->myX
                      atY:((myPointType*)toDraw)->myY
                   ptSize:5];
        };
        
        CGContextSetLineWidth(context, 2.0);
        
        [pointsList walkList:linesDrawer];
        CGContextAddLines(context, addLines, linesAdded);
        CGContextStrokePath(context);
        linesAdded = 0;
        
        [self doaPoint:context margin:margin
                   atX:((myPointType*)[pointsList gotoTail])->myX
                   atY:((myPointType*)[pointsList gotoTail])->myY
                ptSize:10];
    }
    
    // restore the context's state when we are done with it:
    CGContextRestoreGState(context);
}


- (void)sendPoints:(BetterList *)thePoints
{
    pointsList = thePoints;
    [self setNeedsDisplay];
}


@end
