//
//  BetterList.m
//  BetterList
//
//  Created by William Ray on 1/28/12.
//  Copyright (c) 2012 SGF. All rights reserved.
//

#import "BetterList.h"

@implementation BetterList


- (id)initDLList: (void*)anitem 
{
	DLNode *n;
    self = [super init];
    if (self) {
		n = (DLNode *)malloc(sizeof(DLNode));
		n->item = anitem;
		n->next = NULL;
		n->prev = NULL;
		head = n;
        tail = n;
        current = n;
    }
    return self;	
}

- (void *)getCurrent
{
    if(current != NULL)
    {
        return (current->item);
    }
    else
    {
        return NULL;
    }
}

- (void *)getNext
{
    if (current->next != NULL)
    {
        current = current->next;
        return (current->item);
    }
    else
    {
        return NULL;
    }
}


- (void *)getPrev
{
    if (current->prev != NULL)
    {
        current = current->prev;
        return (current->item);
    }
    else
    {
        return NULL;
    }
}


- (void *)gotoHead
{
    current = head;
    return self.getCurrent;
}

- (void *)gotoTail
{
    current = tail;
    return self.getCurrent;
}

- (void *)gotoItemNum: (int)itemNum
{
    DLNode *n = head;
    for(int i=0;i < itemNum;i++)
    {
        if(n)
        {
            n=n->next;
        }
    }
    
    if(n)
    {
        current=n;
    }
    else
    {
        current=tail;
    }
    return self.getCurrent;
}



- (void)insertbefore:(void *)anitem
// inserts before current
{
	DLNode *newNode = (DLNode *)malloc(sizeof(DLNode));
	newNode->item = anitem;
	newNode->next = current;
	newNode->prev = current->prev;
    if(current->prev)
    {
        current->prev->next = newNode;
    }
    current->prev = newNode;
    if (current == head) {
        head = newNode;
    }
    current = newNode;
}

- (void)insertafter:(void *)anitem
// inserts after current
{
	DLNode *newNode = (DLNode *)malloc(sizeof(DLNode));
	newNode->item = anitem;
	newNode->next = current->next;
	newNode->prev = current;
    if(current->next)
    {
        current->next->prev = newNode;
    }
    current->next = newNode;
    if (current == tail) {
        tail = newNode;
    }
    current = newNode;
}

- (void)prepend:  (void*)anitem
{
    DLNode *newNode = (DLNode *)malloc(sizeof(DLNode));
	newNode->item = anitem;
	newNode->next = head;
	newNode->prev = NULL;
    head->prev = newNode;
    head = newNode;
}

- (void)append:   (void*)anitem
{
    DLNode *newNode = (DLNode *)malloc(sizeof(DLNode));
	newNode->item = anitem;
	newNode->prev = tail;
	newNode->next = NULL;
    tail->next = newNode;
    tail = newNode;
}

- (void)replace:  (void*)anitem
{
    free(current->item);
    current->item = anitem;
}

- (void)remove
{
    DLNode *tempNode = NULL;
    if(current)
    {
        if(current->next)
        {
            current->next->prev = current->prev;
            tempNode = current->next;
        }
        if(current->prev)
        {
            current->prev->next = current->next;
            if(tempNode == NULL)
            {
                tempNode = current->prev;
            }
        }
        if(current == head)
        {
            head = current->next;
        }
        if(current == tail)
        {
            tail = current->prev;
        }
        free(current);
        current = tempNode;
    }
}

- (void)walkListSimple
{
    DLNode* walker = head;
    NSLog(@"Startwalksimple");
    while(walker)
    {
        NSLog(@"walk %d",*(int*)walker->item);
        walker = walker->next;
    }
    NSLog(@"Endwalksimple");
}

// No return value
// |    Method name
// |    |          Return type of block argument
// |    |          |     Argument is a Function-Block
// |    |          |     |  Function-Block takes a void* as an argument
// |    |          |     |  |       Name of accepted Function-Block
// |    |          |     |  |       |
- (void)walkList: (void (^)(void*)) doWhat
{
    DLNode* walker = head;
//    NSLog(@"Startwalk");
    while(walker)
    {
//      NSLog(@"walk %d",*(int*)walker->item);
        doWhat(walker->item);
        walker = walker->next;
    }
//    NSLog(@"Endwalk");
}



@end
