//
//  SGFFlipsideViewController.m
//  iBLine
//
//  Created by William Ray on 2/24/12.
//  Copyright (c) 2012 SGF. All rights reserved.
//

#import "SGFFlipsideViewController.h"

@implementation SGFFlipsideViewController
{
    NSMutableArray *thePoints;
    DataPhile *mySharedDataPhile;
    BetterList *myPointsList;
}

@synthesize pointsView = _pointsView;
@synthesize xCoord = _xCoord;
@synthesize yCoord = _yCoord;

@synthesize delegate = _delegate;

- (void)awakeFromNib
{
    NSLog(@"flipside awakeFromNib");
    mySharedDataPhile  = [DataPhile getSharedDataPhile];
    thePoints    = [mySharedDataPhile getDataPhileArray];
    myPointsList = [mySharedDataPhile getPointsList];
    
    int dataInDataPhile = thePoints.count;
    
    self.contentSizeForViewInPopover = CGSizeMake(320.0, 480.0);
    [super awakeFromNib];
    
    NSLog(@"initialized points to %d points",dataInDataPhile);
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
}

- (void)viewDidUnload
{
    [self setXCoord:nil];
    [self setYCoord:nil];
    [self setPointsView:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated
{
	[super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{
	[super viewDidDisappear:animated];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
        return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
    } else {
        return YES;
    }
}

#pragma mark - Actions

- (IBAction)done:(id)sender
{
    [self.delegate flipsideViewControllerDidFinish:self];
}


- (IBAction)plotPoint:(id)sender {
    
    void(^pointsPrinter)(void*) = ^(void* toPrint)
    {
        NSLog(@"point at %f, %f",((myPointType*)toPrint)->myX - 1.0, ((myPointType*)toPrint)->myY - 1.0);
    };
    
    cPoint *aPoint = [[cPoint alloc] init];
    aPoint.x = [_xCoord.text floatValue];
    aPoint.y = [_yCoord.text floatValue];
    [thePoints addObject:aPoint];
    [_pointsView reloadData];
    
    NSLog(@"AddedPoint %f %f",aPoint.x,aPoint.y);
    NSLog(@"points is now %d points",thePoints.count);
    
    
    float normX = aPoint.x + 1.0;
    float normY = aPoint.y + 1.0;
    myPointType *aaPoint = malloc(sizeof(myPointType));
    aaPoint->myX = normX;
    aaPoint->myY = normY;
    
    if (!myPointsList)
    {
        myPointsList = [DataPhile setupPointsList: aaPoint];
    }
    else
    {
        [myPointsList append:aaPoint];
    }
    [myPointsList walkList:pointsPrinter];
    
    [_xCoord resignFirstResponder];
    [_yCoord resignFirstResponder];
    
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    // Return the number of sections.
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    // Return the number of rows in the section.
    return [thePoints count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    UITableViewCell *cell = [tableView 
                             dequeueReusableCellWithIdentifier:@"freeCell"];
	
    cPoint *point = [thePoints objectAtIndex:indexPath.row];
	cell.textLabel.text = [NSString stringWithFormat:@"%0.2f %0.2f",point.x, point.y];
	// cell.detailTextLabel.text = [NSString stringWithFormat:@"%f %f",point.x, point.y];    
    return cell;
}

/*
 // Override to support conditional editing of the table view.
 - (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
 {
 // Return NO if you do not want the specified item to be editable.
 return YES;
 }
 */


- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{
	if (editingStyle == UITableViewCellEditingStyleDelete)
	{
		[thePoints removeObjectAtIndex:indexPath.row];
		[tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
        
        void(^pointsPrinter)(void*) = ^(void* toPrint)
        {
            NSLog(@"point at %f, %f",((myPointType*)toPrint)->myX - 1.0, ((myPointType*)toPrint)->myY - 1.0);
        };
        
        [myPointsList gotoItemNum:indexPath.row];
        [myPointsList remove];
        [myPointsList walkList:pointsPrinter];

	}   
}


/*
 // Override to support rearranging the table view.
 - (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath
 {
 }
 */

/*
 // Override to support conditional rearranging of the table view.
 - (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath
 {
 // Return NO if you do not want the item to be re-orderable.
 return YES;
 }
 */

#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Navigation logic may go here. Create and push another view controller.
    /*
     <#DetailViewController#> *detailViewController = [[<#DetailViewController#> alloc] initWithNibName:@"<#Nib name#>" bundle:nil];
     // ...
     // Pass the selected object to the new view controller.
     [self.navigationController pushViewController:detailViewController animated:YES];
     */
}

@end
