//
//  SimpleViewController.m
//  Library
//
//  Created by John Ray on 2/9/12.
//  Copyright (c) 2012 Poisontooth Enterprises. All rights reserved.
//

#import "SimpleViewController.h"

@implementation SimpleViewController
@synthesize outputField;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView
{
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad
{
    AppDelegate *appDelegate = (AppDelegate *)[[UIApplication sharedApplication] delegate];
    NSManagedObjectContext *objectContext = [appDelegate managedObjectContext];
    
    //Look into fetchRequestWithEntityName
    NSError *error;
    NSFetchRequest *fetchRequest = [[NSFetchRequest alloc] init];
    NSEntityDescription *authorEntity = [NSEntityDescription entityForName:@"Books" 
                                                    inManagedObjectContext:objectContext]; 
    [fetchRequest setEntity:authorEntity];
    NSArray *fetchedObjects = [objectContext executeFetchRequest:fetchRequest error:&error];
    for (Books *aBook in fetchedObjects) {
        NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
        [dateFormatter setDateFormat:@"yyyy"];
        NSString *pubYear;
        pubYear=[dateFormatter stringFromDate:aBook.publicationYear];
        outputField.text=[NSString stringWithFormat:@"%@\n%@ (%@) - %@, %@ (%@)",outputField.text,aBook.title,pubYear,aBook.authorInfo.lastName,aBook.authorInfo.firstName,aBook.authorInfo.email];  
    }   
    
    [super viewDidLoad];
}


- (void)viewDidUnload
{
    [self setOutputField:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

- (IBAction)dismissView:(id)sender {
    [self dismissModalViewControllerAnimated:YES];
}
@end
